Subject: Re: [PATCH v2] ethernet driver for the WIZnet W5300 chip

From: Mike Sinkovsky <[email-masked]>
Date: Wed, 21 Mar 2012 12:20:59 +0600

21.03.2012 0:08, Ben Hutchings написал:
> +static void w5300_get_drvinfo(struct net_device *ndev,
> +			      struct ethtool_drvinfo *info)
> +{
> +	strlcpy(info->driver, DRV_NAME, sizeof(info->driver));
> +	strlcpy(info->version, DRV_VERSION, sizeof(info->version));
> +	strlcpy(info->fw_version, "N/A", sizeof(info->fw_version));
> [...]
>
> Nitpick: if you don't have firmware, don't set fw_version at all.
>
> Ben.

Then ethtool prints empty string as firmware version, I think "N/A" is 
more intuitive.
Can will remove, if it is preferred way.

But I have a question to networking guru's:

This chip have FRAME_SIZE limited to 1514, including eth header.
So, for 802.1Q vlan packets mtu must be set to 1496.
For now we handle this from userspace, but I think this is wrong in general
- handling hardware bugs and limitations is kernels job.

Can driver somehow limit mtu for slave vlan devices to 1496, but still 
use 1500
for plain ethernet?
->ndo_change_mtu is called for master device only, not for it's slaves.

(and sorry for my russian english, just in case)

---
Mike